# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import typing
from .payment_method_fee import PaymentMethodFee
import pydantic
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class FeeCustomizationRailRequest(UniversalBaseModel):
    """
    Examples
    --------
    from mercoa.customization_types import (
        FeeCustomizationRailRequest,
        PaymentMethodFee_Flat,
        PaymentMethodFee_Percentage,
    )

    FeeCustomizationRailRequest(
        ach_standard=PaymentMethodFee_Flat(
            amount=2.5,
        ),
        ach_same_day=PaymentMethodFee_Percentage(
            amount=2.5,
        ),
        check_print=PaymentMethodFee_Flat(
            amount=2.5,
        ),
        check_mail=PaymentMethodFee_Flat(
            amount=2.5,
        ),
    )
    """

    ach_standard: typing.Optional[PaymentMethodFee] = pydantic.Field(alias="ACH_STANDARD", default=None)
    """
    The fee for the ACH standard rail.
    """

    ach_same_day: typing.Optional[PaymentMethodFee] = pydantic.Field(alias="ACH_SAME_DAY", default=None)
    """
    The fee for the ACH same day rail.
    """

    check_print: typing.Optional[PaymentMethodFee] = pydantic.Field(alias="CHECK_PRINT", default=None)
    """
    The fee for the check print rail.
    """

    check_mail: typing.Optional[PaymentMethodFee] = pydantic.Field(alias="CHECK_MAIL", default=None)
    """
    The fee for the check mail rail.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
