# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import typing
from .fee_customization_detail_request import FeeCustomizationDetailRequest
import pydantic
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class FeeCustomizationRequest(UniversalBaseModel):
    """
    Examples
    --------
    from mercoa.customization_types import (
        FeeCustomizationDetailRequest,
        FeeCustomizationRailRequest,
        FeeCustomizationRequest,
        PaymentMethodFee_Flat,
        PaymentMethodFee_Percentage,
    )

    FeeCustomizationRequest(
        payable=FeeCustomizationDetailRequest(
            source=FeeCustomizationRailRequest(
                ach_standard=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                ach_same_day=PaymentMethodFee_Percentage(
                    amount=2.5,
                ),
                check_print=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                check_mail=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
            ),
            destination=FeeCustomizationRailRequest(
                ach_standard=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                ach_same_day=PaymentMethodFee_Percentage(
                    amount=2.5,
                ),
                check_print=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                check_mail=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
            ),
        ),
        receivable=FeeCustomizationDetailRequest(
            source=FeeCustomizationRailRequest(
                ach_standard=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                ach_same_day=PaymentMethodFee_Percentage(
                    amount=2.5,
                ),
                check_print=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                check_mail=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
            ),
            destination=FeeCustomizationRailRequest(
                ach_standard=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                ach_same_day=PaymentMethodFee_Percentage(
                    amount=2.5,
                ),
                check_print=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
                check_mail=PaymentMethodFee_Flat(
                    amount=2.5,
                ),
            ),
        ),
    )
    """

    payable: typing.Optional[FeeCustomizationDetailRequest] = pydantic.Field(default=None)
    """
    When the entity creating the invoice is the payer, these fees will be applied to the transaction.
    """

    receivable: typing.Optional[FeeCustomizationDetailRequest] = pydantic.Field(default=None)
    """
    When the entity creating the invoice is the payee, these fees will be applied to the transaction.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
